* ------------------------------------------------------------
*    Tonkyun Panic Library
*     tonpani
*                                             (C)1995 nenetto
* ------------------------------------------------------------
* $Id: _trans.s,v 1.0 1995/02/13 20:50:50 nenetto Exp $
*
		.xdef	_trans_init
		.xdef	_trans


* ------------------------------------------------------------
*	Cv]̏
*
*	input	d0.l : source gram address
*		d1.l : distination gram address
*		d7.l : ----
*	output	d7.l : ----
*
_trans_init:
		move.l	d0,P_src
		move.l	d1,P_dist
		rts

P_src:		.ds.l	1
P_dist:		.ds.l	1


* ------------------------------------------------------------
*	Cv]
*
*	input	d0.l : mode*$100 +speed
*		d1.l : ----
*		d7.l : count (0..255)
*	output	d7.l : count+speed (0..255) /end flag (=256)
*
_trans:
		movem.l	d0-d6/a0-a6,-(sp)
		
		move.w	d0,d6
		andi.l	#$ff,d6
		subq	#1,d6
		bmi	_trans_end
		
		andi.w	#$1f00,d0
		lsr.w	#7,d0
		move.w	T_trans(pc,d0.w),d0
		jsr	T_trans(pc,d0.w)
		
		movem.l	(sp)+,d0-d6/a0-a6
		rts

_trans_end:	move.l	#256,d7
		movem.l	(sp)+,d0-d6/a0-a6
		rts



T_trans:	.dc.w	__trans00-T_trans	* 0
		.dc.w	__trans01-T_trans
		.dc.w	__trans02-T_trans
		.dc.w	__trans03-T_trans
		.dc.w	__trans04-T_trans
		.dc.w	__trans05-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans		* 8
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__trans00_add-T_trans	* 16
		.dc.w	__trans01_add-T_trans
		.dc.w	__trans02_add-T_trans
		.dc.w	__trans03_add-T_trans
		.dc.w	__trans04_add-T_trans
		.dc.w	__trans05_add-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans		* 24
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans
		.dc.w	__nop-T_trans


__trans00:					* 16line Cv
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			
			move.w	d7,d0
			andi.w	#$f0,d0
			lsl.w	#6,d0
			adda.w	d0,a0
			adda.w	d0,a1
			
			move.w	d7,d0
			andi.l	#$f,d0
			lsl.l	#8,d0
			lsl.l	#6,d0
			adda.l	d0,a0
			adda.l	d0,a1
			
			moveq	#256/8-1,d5
			@@:	move.l	(a0)+,(a1)+
				move.l	(a0)+,(a1)+
				move.l	(a0)+,(a1)+
				move.l	(a0)+,(a1)+
			dbra	d5,@b
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts

__trans00_add:					* 16line Cv
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			
			move.w	d7,d0
			andi.w	#$f0,d0
			lsl.w	#6,d0
			adda.w	d0,a0
			adda.w	d0,a1
			
			move.w	d7,d0
			andi.l	#$f,d0
			lsl.l	#8,d0
			lsl.l	#6,d0
			adda.l	d0,a0
			adda.l	d0,a1
			
			moveq	#256/4-1,d5
			2:	move.w	(a0),d0
				beq	@f
				move.w	d0,(a1)
			@@:	move.w	2(a0),d0
				beq	@f
				move.w	d0,2(a1)
			@@:	move.w	4(a0),d0
				beq	@f
				move.w	d0,4(a1)
			@@:	move.w	6(a0),d0
				beq	@f
				move.w	d0,6(a1)
			@@:	addq	#8,a0
				addq	#8,a1
			dbra	d5,2b
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts



__trans01:					* c Cv
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			
			move.w	d7,d0
			andi.w	#$f0,d0
			lsr.w	#3,d0
			adda.w	d0,a0
			adda.w	d0,a1
			
			move.w	d7,d0
			andi.l	#$f,d0
			lsl.w	#8,d0
			lsl.l	#2+4,d0
			adda.l	d0,a0
			adda.l	d0,a1
			
			moveq	#16-1,d5
			2:	move.w	(a0),(a1)
				move.w	$20(a0),$20(a1)
				move.w	$40(a0),$40(a1)
				move.w	$60(a0),$60(a1)
				move.w	$80(a0),$80(a1)
				move.w	$a0(a0),$a0(a1)
				move.w	$c0(a0),$c0(a1)
				move.w	$e0(a0),$e0(a1)
				move.w	$100(a0),$100(a1)
				move.w	$120(a0),$120(a1)
				move.w	$140(a0),$140(a1)
				move.w	$160(a0),$160(a1)
				move.w	$180(a0),$180(a1)
				move.w	$1a0(a0),$1a0(a1)
				move.w	$1c0(a0),$1c0(a1)
				move.w	$1e0(a0),$1e0(a1)
			lea	$400(a0),a0
			lea	$400(a1),a1
			dbra	d5,2b
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts

__trans01_add:					* c Cv
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			
			move.w	d7,d0
			andi.w	#$f0,d0
			lsr.w	#3,d0
			adda.w	d0,a0
			adda.w	d0,a1
			
			move.w	d7,d0
			andi.l	#$f,d0
			lsl.w	#8,d0
			lsl.l	#2+4,d0
			adda.l	d0,a0
			adda.l	d0,a1
			
			moveq	#16-1,d5
			2:	moveq	#16-1,d4
				3:	move.w	(a0),d0
					beq	@f
					move.w	d0,(a1)
				@@:	lea	$20(a0),a0
					lea	$20(a1),a1
				dbra	d4,3b
			lea	$200(a0),a0
			lea	$200(a1),a1
			dbra	d5,2b
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts



__trans02:					* 
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			
			move.w	d7,d0
			add.w	d0,d0
			adda.w	d0,a0
			adda.w	d0,a1
			
			move.w	#$400+(256-1)*2,d1
			sub.w	d0,d1
			sub.w	d0,d1
			
			moveq	#128-1,d5
			2:	move.w	(a0),(a1)
				move.w	(a0,d1.w),(a1,d1.w)
				lea	$800(a0),a0
				lea	$800(a1),a1
			dbra	d5,2b
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts

__trans02_add:					* 
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			
			move.w	d7,d0
			add.w	d0,d0
			adda.w	d0,a0
			adda.w	d0,a1
			
			move.w	#$400+(256-1)*2,d1
			sub.w	d0,d1
			sub.w	d0,d1
			
			moveq	#128-1,d5
			2:	move.w	(a0),d0
				beq	@f
				move.w	d0,(a1)
			@@:	move.w	(a0,d1.w),d0
				beq	@f
				move.w	d0,(a1,d1.w)
			@@:	lea	$800(a0),a0
				lea	$800(a1),a1
			dbra	d5,2b
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts



__trans03:					*  16*16 block
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			btst	#0,d7
			beq	2f
			moveq	#15,d0
			move.b	d7,d1
			lsr.b	#4,d1
			sub.b	d1,d0
			move.b	d7,d1
			bra	3f
		2:	move.b	d7,d0
			lsr.b	#4,d0
			move.b	d7,d1
		3:	 bsr	_t_16_16
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts

__trans03_add:					*  16*16 block
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			btst	#0,d7
			beq	2f
			moveq	#15,d0
			move.b	d7,d1
			lsr.b	#4,d1
			sub.b	d1,d0
			move.b	d7,d1
			bra	3f
		2:	move.b	d7,d0
			lsr.b	#4,d0
			move.b	d7,d1
		3:	 bsr	_t_16_16_add
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts



__trans04:					* _ line
		lea	Tb_rnd(pc),a2
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			moveq	#0,d0
			move.b	(a2,d7.w),d0
			lsl.w	#8,d0
			lsl.l	#2,d0
			adda.l	d0,a0
			adda.l	d0,a1
			moveq	#256/8-1,d5
			2:	move.l	(a0)+,(a1)+
				move.l	(a0)+,(a1)+
				move.l	(a0)+,(a1)+
				move.l	(a0)+,(a1)+
			dbra	d5,2b
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts

__trans04_add:					* _ line
		lea	Tb_rnd(pc),a2
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			moveq	#0,d0
			move.b	(a2,d7.w),d0
			lsl.w	#8,d0
			lsl.l	#2,d0
			adda.l	d0,a0
			adda.l	d0,a1
			moveq	#256/4-1,d5
			2:	move.w	(a0),d0
				beq	@f
				move.w	d0,(a1)
			@@:	move.w	2(a0),d0
				beq	@f
				move.w	d0,2(a1)
			@@:	move.w	4(a0),d0
				beq	@f
				move.w	d0,4(a1)
			@@:	move.w	6(a0),d0
				beq	@f
				move.w	d0,6(a1)
			@@:	addq	#8,a0
				addq	#8,a1
			dbra	d5,2b
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts



__trans05:					* _ 16*16 block
		lea	Tb_rnd(pc),a2
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			move.b	(a2,d7.w),d1
			move.b	d1,d0
			lsr.b	#4,d0
			 bsr	_t_16_16
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts

__trans05_add:					* _ 16*16 block
		lea	Tb_rnd(pc),a2
		1:	movea.l	P_src(pc),a0
			movea.l	P_dist(pc),a1
			move.b	(a2,d7.w),d1
			move.b	d1,d0
			lsr.b	#4,d0
			 bsr	_t_16_16_add
			addq	#1,d7
			cmp.w	#256,d7
			beq	__trans_end
		dbra	d6,1b
		rts




__trans_end:
__nop:
		move.l	#256,d7
		rts



_t_16_16:
		andi.l	#$f,d0
		andi.l	#$f,d1
		lsl.w	#5,d0
		lsl.w	#8,d1
		lsl.l	#2+4,d1
		add.l	d1,d0
		adda.l	d0,a0
		adda.l	d0,a1

		moveq	#16-1,d1
		2:	move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
			move.l	(a0)+,(a1)+
			lea	$400-16*2(a0),a0
			lea	$400-16*2(a1),a1
		dbra	d1,2b
		rts


_t_16_16_add:
		andi.l	#$f,d0
		andi.l	#$f,d1
		lsl.w	#5,d0
		lsl.w	#8,d1
		lsl.l	#2+4,d1
		add.l	d1,d0
		adda.l	d0,a0
		adda.l	d0,a1

		moveq	#16-1,d1
		2:	move.w	(a0),d0
			beq	@f
			move.w	d0,(a1)
		@@:	move.w	2(a0),d0
			beq	@f
			move.w	d0,2(a1)
		@@:	move.w	4(a0),d0
			beq	@f
			move.w	d0,4(a1)
		@@:	move.w	6(a0),d0
			beq	@f
			move.w	d0,6(a1)
		@@:	move.w	8(a0),d0
			beq	@f
			move.w	d0,8(a1)
		@@:	move.w	10(a0),d0
			beq	@f
			move.w	d0,10(a1)
		@@:	move.w	12(a0),d0
			beq	@f
			move.w	d0,12(a1)
		@@:	move.w	14(a0),d0
			beq	@f
			move.w	d0,14(a1)
		
		@@:	move.w	16(a0),d0
			beq	@f
			move.w	d0,16(a1)
		@@:	move.w	18(a0),d0
			beq	@f
			move.w	d0,18(a1)
		@@:	move.w	20(a0),d0
			beq	@f
			move.w	d0,20(a1)
		@@:	move.w	22(a0),d0
			beq	@f
			move.w	d0,22(a1)
		@@:	move.w	24(a0),d0
			beq	@f
			move.w	d0,24(a1)
		@@:	move.w	26(a0),d0
			beq	@f
			move.w	d0,26(a1)
		@@:	move.w	28(a0),d0
			beq	@f
			move.w	d0,28(a1)
		@@:	move.w	30(a0),d0
			beq	@f
			move.w	d0,30(a1)
		@@:	lea	$400(a0),a0
			lea	$400(a1),a1
		dbra	d1,2b
		rts

Tb_rnd:	.dc.b	$00,$c8,$f2,$0e,$e5,$fa,$6d,$d8,$34,$b3,$a7,$59,$f1,$53,$ff,$f0
	.dc.b	$7d,$3b,$10,$31,$5a,$cb,$c4,$85,$4e,$cf,$5b,$9a,$c6,$de,$ec,$42
	.dc.b	$b7,$ee,$8f,$8b,$40,$84,$b6,$15,$d2,$98,$a9,$2e,$13,$28,$99,$c5
	.dc.b	$4a,$d3,$64,$17,$e0,$03,$7f,$9f,$2c,$54,$c2,$91,$86,$1f,$bb,$56
	.dc.b	$6a,$12,$76,$6b,$0f,$f7,$5f,$bf,$58,$1b,$3f,$c0,$3a,$fd,$05,$3c
	.dc.b	$f4,$02,$5c,$66,$88,$b2,$ce,$a5,$ba,$da,$68,$25,$57,$d6,$d7,$81
	.dc.b	$55,$62,$a6,$26,$2a,$b8,$32,$a3,$f3,$9b,$fe,$39,$7b,$e8,$80,$16
	.dc.b	$dc,$19,$c7,$b1,$6e,$db,$83,$52,$8a,$01,$c1,$aa,$23,$94,$95,$51
	.dc.b	$49,$3d,$24,$e7,$7a,$df,$87,$79,$e4,$69,$50,$5e,$18,$11,$4b,$c3
	.dc.b	$9c,$2b,$29,$71,$09,$a2,$8c,$92,$a4,$2d,$b5,$78,$70,$08,$ac,$7c
	.dc.b	$be,$93,$38,$44,$89,$1e,$97,$5d,$21,$fb,$65,$e6,$4f,$ea,$74,$63
	.dc.b	$8e,$ed,$af,$43,$75,$47,$d4,$eb,$ae,$60,$fc,$ef,$d0,$35,$61,$45
	.dc.b	$cd,$b0,$82,$41,$30,$72,$f9,$c9,$dd,$e1,$f8,$7e,$bd,$07,$0a,$d1
	.dc.b	$1d,$90,$ab,$d5,$6c,$ca,$b9,$a8,$06,$1a,$b4,$8d,$f5,$9e,$46,$77
	.dc.b	$e3,$ad,$73,$36,$4c,$cc,$f6,$14,$33,$48,$4d,$3e,$67,$1c,$0c,$27
	.dc.b	$96,$9d,$a1,$04,$d9,$e2,$22,$20,$37,$0b,$e9,$2f,$6f,$bc,$0d,$a0
* ------------------------------------------------------------


		.end
